<?php
/*------------------------------------------------------------------------
# mod_drilldown_menu - VTEM DrillDown Module
# ------------------------------------------------------------------------
# author Nguyen Van Tuyen
# copyright Copyright (C) 2010 VTEM.NET. All Rights Reserved.
# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Websites: http://www.vtem.net
# Technical Support: Forum - http://vtem.net/en/forum.html
-------------------------------------------------------------------------*/
// no direct access
defined('_JEXEC') or die('Restricted access');
if($params->get('module_usage')){
require_once (JPATH_SITE.DS.'components'.DS.'com_k2'.DS.'helpers'.DS.'route.php');
require_once (JPATH_SITE.DS.'components'.DS.'com_k2'.DS.'helpers'.DS.'utilities.php');
}
class modVTEMDrillDownHelper {

  function hasChildren($id) {

    $user = &JFactory::getUser();
    $aid = (int) $user->get('aid');
    $id = (int) $id;
    $db = &JFactory::getDBO();
    $query = "SELECT * FROM #__k2_categories  WHERE parent={$id} AND published=1 AND trash=0 AND access<={$aid} ";
    $db->setQuery($query);
    $rows = $db->loadObjectList();
    if ($db->getErrorNum()) {
      echo $db->stderr();
      return false;
    }

    if (count($rows)) {
      return true;
    } else {
      return false;
    }
  }

  function treerecurse(&$params, $id = 0, $level = 0, $begin = false) {

    static $output;
    if ($begin) {
      $output = '';
    }

    $root_id = (int) $params->get('root_id');
    $end_level = $params->get('end_level', NULL);
	$id = (int) $id;
    $catid = JRequest::getInt('id');
    $option = JRequest::getCmd('option');
    $view = JRequest::getCmd('view');

    $user = &JFactory::getUser();
    $aid = (int) $user->get('aid');
    $db = &JFactory::getDBO();

    switch ($params->get('categoriesListOrdering')) {

      case 'alpha':
        $orderby = 'name';
        break;

      case 'ralpha':
        $orderby = 'name DESC';
        break;

      case 'order':
        $orderby = 'ordering';
        break;

      case 'reversedefault':
        $orderby = 'id DESC';
        break;

      default:
        $orderby = 'id ASC';
        break;
    }

    if (($root_id != 0) && ($level == 0)) {
      $query = "SELECT * FROM #__k2_categories WHERE parent={$root_id} AND published=1 AND trash=0 AND access<={$aid} ORDER BY {$orderby}";

    } else {
      $query = "SELECT * FROM #__k2_categories WHERE parent={$id} AND published=1 AND trash=0 AND access<={$aid} ORDER BY {$orderby}";
    }

    $db->setQuery($query);
    $rows = $db->loadObjectList();
    if ($db->getErrorNum()) {
      echo $db->stderr();
      return false;
    }
    if ($level < intval($end_level) || is_null($end_level)) {
	  $output .= '<ul class="vtemlevel'.$level.' vtem_k2_menu vt_k2accordion">';
      foreach ($rows as $row) {
        if ($params->get('categoriesListItemsCounter')) {
          $row->numOfItems = ' ('.modVTEMDrillDownHelper::countCategoryItems($row->id).')';
        } else {
          $row->numOfItems = '';
        }

        if (($option == 'com_k2') && ($view == 'itemlist') && ($catid == $row->id)) {
          $active = ' activeCategory';
        } else {
          $active = '';
        }

        if (modVTEMDrillDownHelper::hasChildren($row->id)) {

          $output .= '<li><a class="vtemset'.$level.$active.'" href="'.urldecode(JRoute::_(K2HelperRoute::getCategoryRoute($row->id.':'.urlencode($row->alias)))).'"><span>'.$row->name.$row->numOfItems.'</span></a>';
          modVTEMDrillDownHelper::treerecurse($params, $row->id, $level + 1);
          $output .= '</li>';
        } else {
          $output .= '<li><a class="'.$active.'" href="'.urldecode(JRoute::_(K2HelperRoute::getCategoryRoute($row->id.':'.urlencode($row->alias)))).'"><span>'.$row->name.$row->numOfItems.'</span></a></li>';
        }
      }
      $output .= '</ul>';
    }

    return $output;
  }

  function treeselectbox(&$params, $id = 0, $level = 0) {

    $root_id = (int) $params->get('root_id2');
    $option = JRequest::getCmd('option');
    $view = JRequest::getCmd('view');
    $category = JRequest::getInt('id');
	$id = (int) $id;
    $user = &JFactory::getUser();
    $aid = (int) $user->get('aid');
    $db = &JFactory::getDBO();
    if (($root_id != 0) && ($level == 0)) {
      $query = "SELECT * FROM #__k2_categories WHERE parent={$root_id} AND published=1 AND trash=0 AND access<={$aid} ORDER BY ordering ";
    } else {
      $query = "SELECT * FROM #__k2_categories WHERE parent={$id} AND published=1 AND trash=0 AND access<={$aid} ORDER BY ordering ";
    }

    $db->setQuery($query);
    $rows = $db->loadObjectList();
    if ($db->getErrorNum()) {
      echo $db->stderr();
      return false;
    }

    if ($level == 0) {
      echo '
<div class="vtemk2CategorySelectBlock '.$params->get('moduleclass_sfx').'">
	<form action="'.JRoute::_('index.php').'" method="get">
		<select name="category" onchange="window.location=this.form.category.value;" class="vtem_k2_select">
			<option value="'.JURI::root().'">'.JText::_("-- Select category --").'</option>
			';
    }
    $indent = "";
    for ($i = 0; $i < $level; $i++) {
      $indent .= '&ndash; ';
    }

    foreach ($rows as $row) {
      if (($option == 'com_k2') && ($category == $row->id)) {
        $selected = ' selected="selected"';
      } else {
        $selected = '';
      }
      if (modVTEMDrillDownHelper::hasChildren($row->id)) {
        echo '<option value="'.urldecode(JRoute::_(K2HelperRoute::getCategoryRoute($row->id.':'.urlencode($row->alias)))).'"'.$selected.'>'.$indent.$row->name.'</option>';
        modVTEMDrillDownHelper::treeselectbox($params, $row->id, $level + 1);
      } else {
        echo '<option value="'.urldecode(JRoute::_(K2HelperRoute::getCategoryRoute($row->id.':'.urlencode($row->alias)))).'"'.$selected.'>'.$indent.$row->name.'</option>';
      }
    }

    if ($level == 0) {

      echo '
			</select>
			<input name="option" value="com_k2" type="hidden" />
			<input name="view" value="itemlist" type="hidden" />
			<input name="task" value="category" type="hidden" />
			<input name="Itemid" value="'.JRequest::getInt('Itemid').'" type="hidden" />';

      // For Joom!Fish compatibility
      if (JRequest::getCmd('lang')) {
        echo '<input name="lang" value="'.JRequest::getCmd('lang').'" type="hidden" />';
      }

      echo '
	</form>
</div>
			';

    }
  }

 function countCategoryItems($id) {

    $user = &JFactory::getUser();
    $aid = (int) $user->get('aid');
    $id = (int) $id;
    $db = &JFactory::getDBO();

    $jnow = &JFactory::getDate();
    $now = $jnow->toMySQL();
    $nullDate = $db->getNullDate();

    $query = "SELECT COUNT(*) FROM #__k2_items WHERE catid={$id} AND published=1 AND ( publish_up = ".$db->Quote($nullDate)." OR publish_up <= ".$db->Quote($now)." ) AND ( publish_down = ".$db->Quote($nullDate)." OR publish_down >= ".$db->Quote($now)." ) AND trash=0 AND access<={$aid}";
    $db->setQuery($query);
    $total = $db->loadResult();
    return $total;
  }

  function calendar($params) {

    $month = JRequest::getInt('month');
    $year = JRequest::getInt('year');

    $months = array(JText::_('JANUARY'), JText::_('FEBRUARY'), JText::_('MARCH'), JText::_('APRIL'), JText::_('MAY'), JText::_('JUNE'), JText::_('JULY'), JText::_('AUGUST'), JText::_('SEPTEMBER'), JText::_('OCTOBER'), JText::_('NOVEMBER'), JText::_('DECEMBER'), );
    $days = array(JText::_('SUN'), JText::_('MON'), JText::_('TUE'), JText::_('WED'), JText::_('THU'), JText::_('FRI'), JText::_('SAT'), );

    $cal = new MyCalendar;
    $cal->category = $params->get('calendarCategory', 0);
    $cal->setStartDay(1);
    $cal->setMonthNames($months);
    $cal->setDayNames($days);

    if (($month) && ($year)) {
      return $cal->getMonthView($month, $year);
    } else {
      return $cal->getCurrentMonthView();
    }
  }
  
  //////////////////////////// Menu ////////////////////////////////////
 function GetMenu(&$params) {
        jimport('joomla.application.module.helper');


        $mooduree = $params->get('mooduration', 500);
        $mootransition = $params->get('mootransition', 'Bounce');
        $mooease = $params->get('mooease', 'easeOut');
        $usemootools = $params->get('usemootools', '1');
        $usecss = $params->get('usecss', '1');
        $menuID = $params->get('menuid', 'vt_menu');
		$startlevel = $params->get('startLevel', '0');
        $endlevel = $params->get('endLevel', '10');


        $document = &JFactory::getDocument();
		if($usecss == 1){
        $document->addStyleSheet(JURI::base() . 'modules/mod_vtemmenu/style.css');
		}

        if ($usemootools == 1) {
            JHTML::_("behavior.mootools");
            $document->addScript(JURI::base() . 'modules/mod_vtemmenu/moo_vtemmenu.js');

            $js = "window.addEvent('domready', function() {new DropdownVtemmenu(\$E('div#" . $menuID . "'),{"
                    . "mooTransition : '" . $mootransition . "',"
                    . "mooEase : '" . $mooease . "',"
                    . "mooDuree : " . $mooduree . "});"
                    . "});";

            $document->addScriptDeclaration($js);
        } else {
            $script = 'window.addEvent(\'domready\', function() {
                        var sfEls = document.getElementById("' . $menuID . '").getElementsByTagName("li");
                        for (var i=0; i<sfEls.length; i++) {
	
                            sfEls[i].onmouseover=function() {
                                this.className+=" sfhover";
                            }
		
                            sfEls[i].onmouseout=function() {
                                this.className=this.className.replace(new RegExp(" sfhover\\\\b"), "");
                            }
                        }
                        });';
            $document->addScriptDeclaration($script);
        }
    
        $menutype = $params->get('menutype', 'mainmenu');
        $db = & JFactory::getDBO();
        $query = "
			SELECT *
			FROM #__menu
			WHERE menutype='" . $menutype . "' AND published=1
			ORDER BY sublevel DESC,ordering
			;";
        $db->setQuery($query);
        $rows = $db->loadObjectList('id');

        $user = & JFactory::getUser();
        $urights = $user->get('aid', 0);

        $menu = &JSite::getMenu();
        $active = $menu->getActive();

        $modulesList = modVTEMDrillDownHelper::CreateModulesList();

        $level = 0;
        $items = array();
        $i = 0;


        foreach ($rows as $item) {
            if ($item->sublevel > 0) {
                $rows[$item->parent]->haschild = 'yes';
                if (isset($item->haschild)) {
                    $rows[$item->parent]->enfants.=$item->id . '|' . $item->enfants;
                } else {
                    $rows[$item->parent]->enfants.=$item->id . '|';
                }


               if (isset($active) && $active->id == $item->id) {


                    $j = $item->sublevel;

                    $tempitemID = $item->parent;

                    while ($j != 0) {

                        $rows[$tempitemID]->classe .= " active";

                        $tempitemID = $rows[$tempitemID]->parent;

                        $j--;
                    }
                }
                if (isset($item->haschild)) {
                    $item->classe .= " vtemdrillparent".$item->sublevel;
                }
            }
            if ($item->sublevel == 0 && $urights >= $item->access) { 
                $items[$i] = $item;
                if (isset($item->haschild)) {
                    $item->classe .= " vtemdrillparent".$item->sublevel;
                    $childs = explode("|", $item->enfants);
                    foreach ($childs as $c) {
                        if ($c) {
                            $i++;

                            if (($urights >= $rows[$rows[$c]->parent]->access) && ($urights >= $rows[$c]->access)) {
                                $items[$i] = $rows[$c];
                            } else {
                                $i--;
                            }
                        }
                    }
                }
            } else {
                $i--;
            }
            $i++;
        }



        foreach ($items as $i => &$item) {
            // looking for start and end level
            if (($item->sublevel < $startlevel && $startlevel) || ($item->sublevel > $endlevel)) {
                unset($items[$i]);
                continue;
            }

            // check if item is child of active element
            if ($dependantitems && $startlevel && (
                    ( ($item->sublevel == $active->sublevel + 1) && ($item->parent != $active->id) )
                    || ( isset($items[$lastitem]) && ($item->parent != $items[$lastitem]->id) && ($item->parent != $items[$lastitem]->parent) && ($item->parent != $active->id) )
                    || (!isset($items[$lastitem]) && ($item->parent != $active->id) )
                    )) {
                unset($items[$i]);
                continue;
            }

            $lastitem = $i;
        }


        $niveau_premier = 0;
        $lastitem = 0;
        foreach ($items as $i => &$item) {
            if (!$niveau_premier) {
                $niveau_premier = $items[$i]->sublevel; // important for split menu
            }

            $item->deeper = false;
            $item->shallower = false;
            $item->level_diff = 0;

            if (isset($items[$lastitem])) {
                $items[$lastitem]->deeper = ($item->sublevel > $items[$lastitem]->sublevel);
                $items[$lastitem]->shallower = ($item->sublevel < $items[$lastitem]->sublevel);
                $items[$lastitem]->level_diff = ($items[$lastitem]->sublevel - $item->sublevel);
            }

            $lastitem = $i;

            $item->is_end = !isset($items[$i + 1]);
            if ($item->is_end) {
                if ($startlevel) {
                    $item->level_diff = $item->sublevel - $niveau_premier; //for split menu
                } else {
                    $item->level_diff = $item->sublevel;
                }
            }

            $menu_params = new stdClass();
            $menu_params = new JParameter($item->params);
            $menu_secure = $menu_params->def('secure', 0);

            switch ($item->type) {
                case 'separator':
                    continue;

                case 'url':
                    if ((strpos($item->link, 'index.php?') === 0) && (strpos($item->link, 'Itemid=') === false)) {
                        $item->link = $tmp->link . '&amp;Itemid=' . $item->id;
                    }
                    break;
                case 'alias':
                    $item->link = 'index.php?Itemid=' . $item->params->aliasoptions;

                    break;
                default:
                    $router = JSite::getRouter();
                    if ($router->getMode() == JROUTER_MODE_SEF) {
                        $item->link = 'index.php?Itemid=' . $item->id;
                    } else {
                        $item->link .= '&Itemid=' . $item->id;
                    }
                    break;
            }

            if ($item->home == 1) {
                $item->link = JURI::base();
            } elseif (strcasecmp(substr($item->link, 0, 4), 'http') && (strpos($item->link, 'index.php?') !== false)) {
                $item->link = JRoute::_($item->link, true, $menu_secure);
            } else {
                $item->link = str_replace('&', '&amp;', $item->link);
            }

             $item->classe .= " item" . $item->id;
            if (isset($active) && $active->id == $item->id) {
                $item->classe .= " current active";
            }

            if (preg_match('/\[col\]/', $item->name)) {
                $item->colonne = true;
                $item->name = '';
            }
            $item->divclasse = "";
            if (preg_match('/\[cols(.+)\]/', $item->name, $resultat)) {
                $item->name = preg_replace('/\[cols(.+)\]/', '', $item->name);
                $divclasse = " cols" . $resultat[1];
                $item->divclasse = strval($divclasse);
            }


            $paramsVT = "";
            $masque = "#\[(.+)\]#";
            if (preg_match($masque, $item->name, $resultat)) {
                $paramsVT = $resultat[1];
                $titleVT = preg_replace('/\[' . $resultat[1] . '\]/', '', $item->name);
            } else {
                $titleVT = $item->name;
            }


            if (preg_match('/modname/', $paramsVT)) {
                $item->content = '<div class="vtemmenu_mod">' . modVTEMDrillDownHelper::GenModuleByName($paramsVT, $params) . '<div class="clr"></div></div>';
            } elseif (preg_match('/modid/', $paramsVT)) {
                $item->content = '<div class="vtemmenu_mod">' . modVTEMDrillDownHelper::GenModuleById($paramsVT, $params, $modulesList) . '<div class="clr"></div></div>';
            } else {
                $item->content = "";
            }

           $titleVT = explode("||", $titleVT);
            if (isset($titleVT[1])) {
                $titleVT = $titleVT[0] . '<span class="vt_desc">' . $titleVT[1] . '</span>';
            } else {
                $titleVT = $titleVT[0];
            }


            $menu_image = $menu_params->def('menu_image', -1);
            $item->image_lft = "";
            $item->image_rgt = "";
            if (($menu_image <> '-1') && $menu_image) {
                $image = '<img src="' . JURI::base(true) . '/images/stories/' . $menu_image . '" border="0" alt="' . $item->name . '"/>';
                if ($params->get('menu_images_align')) {
                    $item->image_rgt = $image;
                } else {
                    $item->image_lft = $image;
                }
            }


            $item->name = $titleVT;
        }



        return $items;
    }

    function GenModuleByName($paramsVT, &$params) {
        $paramsVT = preg_replace('/modname=/', '', $paramsVT);
        if (JModuleHelper::isEnabled($paramsVT)) {
            $module = JModuleHelper::getModule($paramsVT);
            $attribs['style'] = 'xhtml';
            return JModuleHelper::renderModule($module, $attribs);
        }
    }

    function GenModuleById($paramsVT, &$params, &$modulesList) {
        $paramsVT = preg_replace('/modid=/', '', $paramsVT);
        $modtitle = $modulesList[$paramsVT]->title;
        $modname = $modulesList[$paramsVT]->module;
        $modname = preg_replace('/mod_/', '', $modname);

        if (JModuleHelper::isEnabled($modname)) {
            $module = JModuleHelper::getModule($modname, $modtitle);
               $attribs['style'] = 'xhtml';
            return JModuleHelper::renderModule($module, $attribs);
        }
    }

    function CreateModulesList() {
        $db = & JFactory::getDBO();
        $query = "
			SELECT *
			FROM #__modules
			WHERE published=1
			ORDER BY id
			;";
        $db->setQuery($query);
        $modulesList = $db->loadObjectList('id');
        return $modulesList;
    }

}
