<?php
/*------------------------------------------------------------------------
# mod_drilldown_menu - VTEM DrillDown Module
# ------------------------------------------------------------------------
# author Nguyen Van Tuyen
# copyright Copyright (C) 2010 VTEM.NET. All Rights Reserved.
# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Websites: http://www.vtem.net
# Technical Support: Forum - http://vtem.net/en/forum.html
-------------------------------------------------------------------------*/
// no direct access
defined('_JEXEC') or die('Restricted access');
$menulabel = $params->get('menulabel', 'You chose');
$maxHeight = $params->get('maxHeight', 200);
$showSpeed = $params->get('showSpeed', 150);
$crossSpeed = $params->get('crossSpeed', 200);
$backLink = $params->get('backLink',1);
$backLinkText = $params->get('backLinkText','Back');
$topLinkText = $params->get('topLinkText','All');
$script = $params->get('script',1);
$style = $params->get('style', 0);
$vtemstyle = $params->get('vtemstyle',1);
if($style == 1) $vtemstyle = "";
$width = $params->get('width','200');

$background = $params->get('background','#555');
$textcolor = $params->get('textcolor','#ccc');
$sub_background = $params->get('sub_background','#777');
$sub_textcolor = $params->get('sub_textcolor','#ccc');
$hovertextcolor = $params->get('hovertextcolor','#f90');
$sub_backgroundcolor = $params->get('sub_backgroundcolor','#333');
$css = $params->get('css');

$doc = &JFactory::getDocument();
$doc->addStyleSheet(JURI::root().'modules/mod_vtem_drilldown_menu/main/default.css');
$doc->addStyleSheet(JURI::root().'modules/mod_vtem_drilldown_menu/theme/style'.$vtemstyle.'.css');

if ($script == 1){
echo "<script src='".JURI::root()."modules/mod_vtem_drilldown_menu/main/jquery-1.6.1.min.js' type='text/javascript'></script>";
}
?>
<script type="text/javascript" src="<?php echo JURI::root();?>modules/mod_vtem_drilldown_menu/main/menu.js"></script>
<script type="text/javascript">
var vtemdrilldown = jQuery.noConflict();
(function($) {
$(document).ready(function(){
	$('#ID<?php echo $slideID;?>').menu({
		content: $('#ID<?php echo $slideID;?>').next().html(),		
		width: <?php echo $width;?>,
		maxHeight: <?php echo $maxHeight;?>,
		showSpeed: <?php echo $showSpeed;?>,
		crossSpeed: <?php echo $crossSpeed;?>,
		backLink: <?php echo $backLink;?>,
		backLinkText: '<?php echo $backLinkText;?>',
		topLinkText: '<?php echo $topLinkText;?>'
	});
});
})(jQuery);
</script>
<style type="text/css">
.vtemdrildown{*width:100px;text-decoration:none !important;}
.fg-menu-breadcrumb li a,.fg-menu-breadcrumb li{width:auto !important;}
<?php if($style == 1){?>
.vtemdrildown,.vtemdrildown:link,.vtemdrildown:visited,.vtemdrildown:focus{background-color:<?php echo $background;?>;color:<?php echo $textcolor;?>;}
.fg-menu-container{background-color:<?php echo $sub_background;?>;}
.fg-menu-container .fg-menu li a{color:<?php echo $sub_textcolor;?>;}
.vtemdrildown:hover,.fg-menu-open,.fg-menu-container .fg-menu li a:hover{color:<?php echo $hovertextcolor;?> !important; background:<?php echo $sub_backgroundcolor;?>;}
<?php }
echo $css;?>
</style>
<div class="vtemdrildown_wrapper" id="vtemdrilldown">
<a tabindex="0" href="#<?php echo $slideID;?>" class="vtemdrildown vtemdrillround" id="ID<?php echo $slideID;?>"><?php echo $menulabel;?><span class="vtemdrillarrow">&nbsp;</span></a>
<div id="<?php echo $slideID;?>" class="hidden vt_drilldown_menu<?php echo $params->get('moduleclass_sfx'); ?>">
	<ul>
		<?php 
			$user = & JFactory::getUser();
			foreach ($items as $i => &$row)		{
				if ($row->access <= $user->get('aid', 0)) {
					if ($row->content) {
						echo '<li class="'.$row->classe.'">'.$row->content;
					}
					elseif (isset($row->colonne)) {
						echo '</ul><ul class="vtemlevel'.$row->sublevel.'">';
					}
					elseif ($row->name != "") {
						echo '<li>';
								switch ($row->type) :
									default:
									case 'separator':
										echo $row->image_lft.'<span class="vt_title">'.$row->name.'</span>'.$row->image_rgt;
										break;
									case 'url':
									case 'component':
										switch ($row->browserNav) :
											default:
											case 0:
												echo '<a class="'.$row->classe.'" href="'.$row->link.'">'.$row->image_lft.'<span class="vt_title">'.$row->name.'</span></a>'.$row->image_rgt;
												break;
											case 1:
												// _blank
												echo $row->image_lft.'<a class="'.$row->classe.'" href="'.$row->link.'" target="_blank"><span class="vt_title">'.$row->name.'</span></a>'.$row->image_rgt;
												break;
											case 2:
												echo $row->image_lft.'<a class="'.$row->classe.'" href="'.$row->link.'&tmpl=component" onclick="window.open(this.href,\'targetWindow\',\'$attribs\');return false;"><span class="vt_title">'.$row->name.'</span></a>'.$row->image_rgt;			
												break;
										endswitch;
										break;
								endswitch;
					}
				}
					
					if ($row->deeper)
					{	
						echo '<ul class="vtemdrilllevel'.$row->sublevel.'">';
					}
					// The next item is shallower.
					elseif ($row->shallower)
					{
						echo "\n\t</li>";
						
						echo str_repeat("\n\t</ul>\n\t</li>", $row->level_diff);
					}
					// the item is the last.
					elseif ($row->is_end)
					{			
						echo str_repeat("</li>\n\t</ul>", $row->level_diff);
						echo "</li>";
					}
					// The next item is on the same level.
					else {
						if (!isset($row->colonne)) echo "\n\t\t</li>\n";
					}
			}
		?>
	</ul>
</div>
<div style="clear:both"></div>
</div>
